<?php
/**
 * RSS订阅权限：passkey
 * 种子下载权限：hash（AES对称加密）
 * Tracker权限：authkey（AES对称加密 | HASH加密）
 */
include __DIR__ .'/ICrypt.php';
$pass = '站点唯一的密钥';
$uid  = '321611';   // 用户id
/**
 * 种子下载链接加密
 * @desc AES对称加密生成hash（受控于passkey，各用户拥有独立的passkey）
 * 注意：重置passkey时，影响用户RSS订阅链接，不影响用户Tracker汇报；
 */
echo '------------------------------------'.PHP_EOL;
# 1. 根据用户uid查询出passkey
$passkey = 'MIIEowIBAAKCAQEA4T9gNTdx3jQXTWtsbz7V8BbNGxvLNNxdcOZiWmMreH8wFaeL';
# 2. 用户download加密key（每天变化）
$key = sha1($passkey . $pass . date("Ymd")) . $uid;
echo '用户download加密密钥：'.$key.PHP_EOL;
# 3. 加密参数
$config = [
    'method' => 'AES-128-CBC',      //加密方式 AES-256-CBC等
    'key'    => $key,               //加密key
    'iv'     => md5($key, true),    //保证偏移量为16位
];
# 4. 模拟加密解密的全部过程
$id = 9129016;      // 种子id
while ($id > 9129013) {
    $data = $uid.'.'.$id;       // 原始数据
    echo '原始数据：'.$data;
    $hash = ICrypt::encode($data, $config);     // 加密
    echo ' | AES加密torrent_id：download.php?hash='.$hash.'&uid='.$uid.' ('.strlen($hash).'位)';
    echo ' | AES解密torrent_id：'.ICrypt::decode($hash, $config).PHP_EOL;      //解密
    $id--;
}

/**
 * 种子Tracker链接加密
 * @desc AES对称加密生成hash（受控于secret，各用户拥有独立的secret）
 * 优势：重置单个种子时，把torrent_id、uid、新secret写入数据表torrent_secret，不影响用户Tracker汇报、不影响用户RSS订阅连接；
 * 注意：重置secret时，影响用户所有种子Tracker汇报，不影响用户RSS订阅连接（应删除数据表torrent_secret内当前用户数据）
 */
echo '------------------------------------'.PHP_EOL;
# 1. 根据用户uid查询出secret
$secret = 'biwbSB6Pqd/H1fmQSI28uLUzgwXCv1uAE3L2liy8WJOrcH9mxl9qMyBoeyB7QswG';    // 全局 用户独立
# 2. 用户tracker加密key
$key = sha1($secret . $pass) . $uid;
echo '用户Tracker加密密钥：'.$key.PHP_EOL;
# 3. 加密参数
$config = [
    'method' => 'AES-128-CBC',      //加密方式 AES-256-CBC等
    'key'    => $key,               //加密key
    'iv'     => md5($key, true),    //保证偏移量为16位
];
# 4. 模拟加密解密的全部过程
$id = 412900016;    // 种子id
while ($id > 412900013) {
    $data = json_encode(['id' => $id,'uid' => $uid], JSON_UNESCAPED_UNICODE);   // 原始数据
    echo '原始数据：'.$data;
    $hash = ICrypt::encode($data, $config);     // 加密
    echo ' | 方法一.AES加密Tracker：announce.php?authkey='.$hash.'&uid='.$uid.' ('.strlen($hash).'位)';
    echo ' | AES解密Tracker：'.ICrypt::decode($hash, $config);     // 解密
    echo ' | 方法二.HASH加密Tracker：announce.php?authkey='.$uid.'.'.sha1($key.$id).PHP_EOL;
    $id--;
}
echo '------------------------------------'.PHP_EOL;
